function Housing = importfile_Osaka(filename, startRow, endRow)
%IMPORTFILE eLXg t@C琔lf[^sƂăC|[g܂B
%   HOUSING = IMPORTFILE(FILENAME) ̑IɂĂ eLXg t@C FILENAME
%   f[^ǂݎ܂B
%
%   HOUSING = IMPORTFILE(FILENAME, STARTROW, ENDROW) eLXg t@C FILENAME 
%   STARTROW s ENDROW s܂ł̃f[^ǂݎ܂B
%
% Example:
%   Housing = importfile('Housing_Osaka_preprocessed.csv', 2, 373);
%
%    TEXTSCAN QƂĂB

% MATLAB ɂ鎩 2016/10/14 12:49:01

%% ϐ܂B
delimiter = ',';
if nargin<=2
    startRow = 2;
    endRow = inf;
end

%% eLXg̊es̏ݒ:
%   1: double (%f)
%	2: double (%f)
%   3: eLXg (%s)
%	4: double (%f)
%   5: double (%f)
%	6: double (%f)
%   7: double (%f)
%	8: double (%f)
%   9: eLXg (%s)
%	10: double (%f)
%   11: double (%f)
%	12: eLXg (%s)
%   13: double (%f)
%	14: double (%f)
%   15: double (%f)
%	16: double (%f)
%   17: double (%f)
%	18: double (%f)
% ڍׂ TEXTSCAN ̃hLe[VQƂĂB
formatSpec = '%f%f%s%f%f%f%f%f%s%f%f%s%f%f%f%f%f%f%[^\n\r]';

%% eLXg t@CJ܂B
fileID = fopen(filename,'r');

%% f[^̗ݒɏ]ēǂݎ܂B
% ̌ĂяóÃR[h̐Ɏgpꂽt@C̍\ɊÂĂ܂Bʂ̃t@CŃG[ꍇ́AC|[g
% c[R[h̍Đ݂ĂB
dataArray = textscan(fileID, formatSpec, endRow(1)-startRow(1)+1, 'Delimiter', delimiter, 'EmptyValue' ,NaN,'HeaderLines', startRow(1)-1, 'ReturnOnError', false, 'EndOfLine', '\r\n');
for block=2:length(startRow)
    frewind(fileID);
    dataArrayBlock = textscan(fileID, formatSpec, endRow(block)-startRow(block)+1, 'Delimiter', delimiter, 'EmptyValue' ,NaN,'HeaderLines', startRow(block)-1, 'ReturnOnError', false, 'EndOfLine', '\r\n');
    for col=1:length(dataArray)
        dataArray{col} = [dataArray{col};dataArrayBlock{col}];
    end
end

%% eLXg t@C܂B
fclose(fileID);

%% C|[głȂf[^̌㏈B
% C|[gɁAC|[głȂf[^̋KKpȂ߁A㏈R[h܂܂Ă܂BC|[głȂf[^ɓKpłR[h𐶐ɂ́At@C̃C|[głȂZIĂXNvgĐ܂B

%% o͕ϐ̍쐬
Housing = table(dataArray{1:end-1}, 'VariableNames', {'longitude','latitude','ward','ChangeRate','acreage','shape','road','transportation','neighborhood','shape_flag','usage_floor','building','build_house','build_store','build_office','build_warehouse','build_factory','value'});

