function HousingOsaka = importfile_Osaka_preprocessing(filename)
%  Copyright 2016 The MathWorks, Inc.
%% eLXg t@Cf[^C|[g܂B
% ̃eLXg t@Cf[^C|[gXNvg:
% R[hقȂIf[^eLXg t@CɊgɂ́AXNvgł͂Ȃ֐𐶐܂B

% MATLAB ɂ鎩 2016/10/12 21:06:44

%% ϐ܂B
delimiter = ',';
startRow = 2;

%% f[^̗eLXgƂēǂݎ:
% ڍׂ TEXTSCAN ̃hLe[VQƂĂB
formatSpec = '%s%s%s%*s%s%s%s%s%s%s%*s%s%s%[^\n\r]';

%% eLXg t@CJ܂B
fileID = fopen(filename,'r');

%% f[^̗ݒɏ]ēǂݎ܂B
% ̌ĂяóÃR[h̐Ɏgpꂽt@C̍\ɊÂĂ܂Bʂ̃t@CŃG[ꍇ́AC|[g
% c[R[h̍Đ݂ĂB
dataArray = textscan(fileID, formatSpec, 'Delimiter', delimiter, 'HeaderLines' ,startRow-1, 'ReturnOnError', false, 'EndOfLine', '\r\n');

%% eLXg t@C܂B
fclose(fileID);

%% leLXg܂ޗ̓e𐔒lɕϊ܂B
% 񐔒leLXg NaN Œu܂B
raw = repmat({''},length(dataArray{1}),length(dataArray)-1);
for col=1:length(dataArray)-1
    raw(1:length(dataArray{col}),col) = dataArray{col};
end
numericData = NaN(size(dataArray{1},1),size(dataArray,2));

for col=[1,2,4,5,6,8,10]
    % ̓Zz̃eLXg𐔒lɕϊ܂B񐔒leLXg NaN Œu܂B
    rawData = dataArray{col};
    for row=1:size(rawData, 1);
        % lłȂړƐڔoč폜鐳K\쐬܂B
        regexstr = '(?<prefix>.*?)(?<numbers>([-]*(\d+[\,]*)+[\.]{0,1}\d*[eEdD]{0,1}[-+]*\d*[i]{0,1})|([-]*(\d+[\,]*)*[\.]{1,1}\d+[eEdD]{0,1}[-+]*\d*[i]{0,1}))(?<suffix>.*)';
        try
            result = regexp(rawData{row}, regexstr, 'names');
            numbers = result.numbers;
            
            % ؂ȊȌꏊŃR}o܂B
            invalidThousandsSeparator = false;
            if any(numbers==',');
                thousandsRegExp = '^\d+?(\,\d{3})*\.{0,1}\d*$';
                if isempty(regexp(numbers, thousandsRegExp, 'once'));
                    numbers = NaN;
                    invalidThousandsSeparator = true;
                end
            end
            % leLXg𐔒lɕϊ܂B
            if ~invalidThousandsSeparator;
                numbers = textscan(strrep(numbers, ',', ''), '%f');
                numericData(row, col) = numbers{1};
                raw{row, col} = numbers{1};
            end
        catch me
        end
    end
end


%% f[^𐔒lƃZɕ܂B
rawNumericColumns = raw(:, [1,2,4,5,6,8,10]);
rawCellColumns = raw(:, [3,7,9,11]);


%% 񐔒lZ̒lŒu NaN
R = cellfun(@(x) ~isnumeric(x) && ~islogical(x),rawNumericColumns); % 񐔒lZ
rawNumericColumns(R) = {NaN}; % 񐔒lZu

%% o͕ϐ̍쐬
HousingOsaka = table;
HousingOsaka.VarName1 = cell2mat(rawNumericColumns(:, 1));
HousingOsaka.VarName2 = cell2mat(rawNumericColumns(:, 2));
HousingOsaka.VarName3 = rawCellColumns(:, 1);
HousingOsaka.VarName4 = cell2mat(rawNumericColumns(:, 3));
HousingOsaka.VarName5 = cell2mat(rawNumericColumns(:, 4));
HousingOsaka.VarName6 = cell2mat(rawNumericColumns(:, 5));
HousingOsaka.VarName7 = rawCellColumns(:, 2);
HousingOsaka.VarName8 = cell2mat(rawNumericColumns(:, 6));
HousingOsaka.VarName9 = rawCellColumns(:, 3);
HousingOsaka.VarName10 = cell2mat(rawNumericColumns(:, 7));
HousingOsaka.VarName11 = rawCellColumns(:, 4);

%% ꎞϐ̃NA
clearvars filename delimiter startRow formatSpec fileID dataArray ans raw col numericData rawData row regexstr result numbers invalidThousandsSeparator thousandsRegExp me rawNumericColumns rawCellColumns R;